/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.gruppe.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.gruppe.entity.PolitischeGruppe;
import de.ivu.elect.business.gruppe.entity.PolitischeGruppeUK;

public abstract class AbstractPolitischeGruppeDAO extends de.ivu.elect.jee.entity.AbstractDAO<PolitischeGruppe,
      de.ivu.elect.business.gruppe.entity.GruppePK
  , PolitischeGruppeUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractPolitischeGruppeDAO.class);

  public AbstractPolitischeGruppeDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.gruppe.entity.GruppePK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public PolitischeGruppe findByPrimaryKey(
      de.ivu.elect.business.gruppe.entity.GruppePK
    pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected PolitischeGruppe findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(PolitischeGruppe.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: OhneWahlAndSchluesselNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl IS NULL AND gruppe.schluessel=?1<br>
      * SQL: <br>
      */
     public PolitischeGruppe findByOhneWahlAndSchluessel( @javax.annotation.Nonnull String schluessel) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  String schluesselCheckedAndAttached =  checkAndAttach(schluessel, String.class, "schluessel"); ;
		  
                              return
                    (PolitischeGruppe)
                              getEntityManager().
                                createNamedQuery("POLITISCHE_GRUPPE.OhneWahlAndSchluessel")
                              .setParameter(1, schluesselCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PolitischeGruppe, findByOhneWahlAndSchluessel - NonUniqueResultException, Parameter: "
           + ", schluessel:'"+schluessel+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByOhneWahlAndSchluessel(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: OhneWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl IS NULL ORDER BY gruppe.schluessel<br>
      * SQL: <br>
      */
     public java.util.List<PolitischeGruppe> findByOhneWahl() {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  
                              return
                              getEntityManager().
                                createNamedQuery("POLITISCHE_GRUPPE.OhneWahl")
                                                            .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByOhneWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PolitischeGruppe, findByOhneWahl - NonUniqueResultException, Parameter: "
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByOhneWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndGruppeArtenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 AND gruppe.gruppeArt IN (?2) ORDER BY gruppe.schluessel<br>
      * SQL: <br>
      */
     public java.util.List<PolitischeGruppe> findByWahlAndGruppeArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gruppe.entity.GruppeArt> gruppeArten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.util.Collection<de.ivu.elect.business.gruppe.entity.GruppeArt> gruppeArtenCheckedAndAttached =  gruppeArten ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("POLITISCHE_GRUPPE.WahlAndGruppeArten")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gruppeArtenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndGruppeArten - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PolitischeGruppe, findByWahlAndGruppeArten - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gruppeArten:'"+gruppeArten+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndGruppeArten(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 ORDER BY gruppe.schluessel<br>
      * SQL: <br>
      */
     public java.util.List<PolitischeGruppe> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("POLITISCHE_GRUPPE.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PolitischeGruppe, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlOrderByKurznameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 ORDER BY gruppe.kurzname<br>
      * SQL: <br>
      */
     public java.util.List<PolitischeGruppe> findByWahlOrderByKurzname( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("POLITISCHE_GRUPPE.WahlOrderByKurzname")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PolitischeGruppe, findByWahlOrderByKurzname - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlOrderByKurzname(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.gruppe.entity.PolitischeGruppeUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.gruppe.entity.PolitischeGruppeUK uk,
      de.ivu.elect.business.gruppe.entity.GruppePK
    pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.gruppe.entity.PolitischeGruppe findByUK(de.ivu.elect.business.gruppe.entity.PolitischeGruppeUK uk){

    try {
     return (de.ivu.elect.business.gruppe.entity.PolitischeGruppe) getEntityManager().createNamedQuery("POLITISCHE_GRUPPE.UK")
                  .setParameter(1, uk
                .getSchluessel ()  
              )
             .setParameter(2, uk
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(3, uk
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(4, uk
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(5, uk
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(6, uk
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("PolitischeGruppe, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}